class Point2d
  attr_accessor :x, :y

  def initialize(x=0, y=0)
    @x = x
    @y = y
  end

  def +(other)
    Point2d.new(x+other.x, y+other.y)
  end

  def -(other)
    Point2d.new(x-other.x, y-other.y)
  end

  def *(factor)
    Point2d.new(x*factor, y*factor)
  end

  def /(factor)
    Point2d.new(x/factor, y/factor)
  end

  def cross(other)
    x*other.y - y*other.x
  end
  alias % cross

  def dot(other)
    x*other.x + y*other.y
  end
  alias ^ dot
end
